
AchievementNoHealhtPotions = class(Turbine.UI.Control)
function AchievementNoHealhtPotions:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.effectList = {
        ["Increased Morale"] = true,
        ["Morale Restoration"] = true,
    }

    self.timer = 0
    self.effectCallback = AddCallback(ChatEventHandler, "PlayerHeal", function(args)
        if self.effectList[args.SkillName] then
            if not( self.updateCallback) then
                self.timer = 2
                self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
            end
        end
    end)

    self.benefitCallback = AddCallback(ChatEventHandler, "PlayerBenefit", function(args)
        if args.SkillName == "Nature's Gift" then
            self.LMHeal = true
        end
    end)

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        if self.timer < 0 then
            if self.LMHeal then
                self.LMHeal = false
            else
                handler:Fail("No health Potions", "Used a healing potion", 0x410D9923)
            end
            if self.updateCallback then
                RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
                self.updateCallback = nil
            end
        end

    end
end

function AchievementNoHealhtPotions:Unload()
    if self.updateCallback then
        RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
        self.updateCallback = nil
    end
    RemoveCallback(ChatEventHandler, "PlayerHeal", self.effectCallback)
    RemoveCallback(ChatEventHandler, "PlayerBenefit", self.benefitCallback)
end